SystemOrganization addCategory: #'MC2-Tests-Core'!

Object subclass: #MDTestBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
definition: aSymbol
	| definition |
	definition := MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:26'!
memo
	^ self memo: #abc! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/22/2010 20:54'!
memo: aSymbol 
	^ MDMemo 
		ancestry: MDAncestry empty
		properties: (MDPropertyDictionary new
				id: aSymbol;
				yourself)
		slice: self slice
		snapshot: self snapshot! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/18/2010 22:13'!
slice
	^ MDExplicitSlice forTesting! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/20/2010 10:37'!
sliceVariant
	| slice variant environment facade |
	environment := MDEnvironment forTesting.
	facade := MDMonticelloFacade environment: environment.
	slice := environment addSlice: self slice.
	variant := MDDefinitionVariant forElement: slice asElement.
	facade updateVariant: variant.
	^ variant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/23/2008 07:14'!
sliceVersion
	^ MDElementVersion variant: self sliceVariant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 8/17/2010 10:05'!
snapshot: aBlock
	| versions |
	versions := self versions.
	aBlock value: versions.
	^ MDSnapshot sliceId: MDHashstamp new versions: versions! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/21/2010 23:31'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^ anElementVersion childWithVariant: newVariant.! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionFor: elementName with: value
	| element snapshot |
	element := MDFakeElement named: elementName.
	snapshot := MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionWith: value
	| snapshot |
	snapshot := MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 8/17/2010 10:05'!
versions
	^ Set new
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta');
		yourself.
	! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'facade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 8/9/2010 10:12'!
adapt: anElement
	^ facade adapt: anElement! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'jf 1/19/2010 22:34'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update: merge:into:onFailure: isLoadable:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'cwp 7/20/2010 09:17'!
facadeClass
	self subclassResponsibility! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 7/20/2010 09:17'!
setUp
	facade := self facadeClass new! !

!MDAdaptionTest methodsFor: 'constructing' stamp: 'cwp 1/18/2010 22:06'!
slice
	^ MDExplicitSlice forTesting! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 8/9/2010 10:12'!
tryAdapting: anElement
	| adaptor |
	adaptor := self adapt: anElement.
	self adaptorSelectors do: [ :ea | self assert: (adaptor respondsTo: ea) ]! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAdaptorTest class methodsFor: 'testing' stamp: 'jf 1/31/2010 12:41'!
isAbstract
	^ self name = #MDAdaptorTest! !

!MDAdaptorTest class methodsFor: 'testing' stamp: 'jf 1/31/2010 12:32'!
shouldInheritSelectors
	^ true! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'jf 1/31/2010 12:32'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'jf 1/31/2010 12:35'!
adaptorForElement: anElement
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'asserting' stamp: 'jf 1/31/2010 12:32'!
assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'jf 1/31/2010 12:32'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
canBeOutOfDate
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
canBeUnloadable
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 16:27'!
changedValue
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
createObject
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 16:01'!
destroyObject
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
displayString
	^ self properties asString! !

!MDAdaptorTest methodsFor: 'running' stamp: 'jf 1/31/2010 12:38'!
editDuring: aBlock
	^ aBlock value! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'jf 1/31/2010 15:59'!
element
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'jf 1/31/2010 12:32'!
initials
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 16:23'!
objectIsPresent
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'jf 1/31/2010 12:32'!
properties
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'running' stamp: 'jf 1/31/2010 12:32'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testIsUnloadable
	| adaptor |
	self canBeUnloadable ifTrue: 
		[ adaptor := self adaptorForElement: self unloadableElement.
		self deny: (adaptor isLoadable: self unloadableProperties) ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testIsUpToDate
	self createObject.
	self assert: (self adaptor isUpToDate: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testLoad
	self editDuring: [self adaptor load: self properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testNotUpToDate
	| properties |
	self canBeOutOfDate ifTrue: [
		self propertyToChange ifNil: [^ self].
		self createObject.
		properties := self properties.
		properties at: self propertyToChange put: self changedValue.
		self deny: (self adaptor isUpToDate: properties) ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testRemove
	self createObject.
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testRemoveNotPresent
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testUnloadableNotPresent
	| adaptor |
	self canBeUnloadable ifTrue: 
		[ adaptor := self adaptorForElement: self unloadableElement.
		self deny: adaptor isPresent ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assert: properties = self properties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 1/31/2010 12:32'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'jf 1/31/2010 12:32'!
timeStamp
	^ MDTimestamp fromSqueakMethodStamp: self stamp! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
unloadableElement
	"Returns an element that, combined with #unloadableProperties,
	cannot be loaded."
	
	^ self element! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 1/31/2010 12:32'!
unloadableProperties
	"Returns properties that, when applied to #unloadableElement, result in the
	element being unloadable."
	
	^ self properties! !

TestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 7/13/2010 16:05'!
null
	^ MDNullVersion forElement: self builder element! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 7/13/2010 16:08'!
setUp
	parent := self builder version.
	child := self builder updateVersion: parent property: #foo put: 'alpha2'! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 7/13/2010 16:08'!
sibling
	^ self builder updateVersion: parent property: #bar put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 1/21/2010 18:47'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 1/21/2010 18:48'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:04'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child
		successor: sibling
		onConflict: [ 
			result := self builder definition.
			result properties at: #merged put: true.
			result ].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged variant properties merged! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 1/21/2010 18:48'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 1/21/2010 18:48'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

TestCase subclass: #MDBenchTest
	instanceVariableNames: 'builder bench slice repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2010 21:48'!
assert: elementName hasValue: expected
	| element facade actual |
	element := MDFakeElement named: elementName.
	facade := (bench workspaceForSlice: slice) facade.
	actual := (facade at: element) at: #one.
	self assert: actual = expected! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2010 11:36'!
setAlphaToOne
	
	| element facade |
	element := builder element.
	facade := (bench workspaceForSlice: slice) facade.
	(facade at: element) at: #one put: 'one'
		! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2010 10:42'!
setUp
	builder := MDTestBuilder new.
	bench := MDBench new.
	slice := self slice.
	repository := MDMemoryRepository forTesting.
! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2010 10:16'!
slice
	^ (MDExplicitSlice forTesting)
		addElement: (self builder element: #Alpha);
		addElement: (self builder element: #Beta);
		yourself! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2010 11:53'!
testBubbleUp
	| bundle baseline snapshot |
	self setAlphaToOne.
	bundle := MDBundle forTesting.
	bundle addSlice: slice.
	snapshot := bench save: slice to: repository.
	baseline := bench save: bundle to: repository.
	self assert: (baseline contents includes: snapshot hashstamp).
	! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 16:21'!
testLoadBundle
	| versions snapshot bundle baseline |
	bundle := MDBundle forTesting.
	bundle addSlice: slice.
	versions := builder versions.
	snapshot := slice snapshotWithVersions: versions.
	baseline := bundle baselineWithSnapshots: (Set with: snapshot).
	repository putAll: versions.
	repository put: snapshot.
	repository put: baseline.
	bench load: baseline from: repository slice: bundle.
	self assert: (bench assemblyForEnum: bundle) = baseline.
	self assert: (bench assemblyForEnum: slice) = snapshot.
	self assert: #Alpha hasValue: 'alpha'.
	self assert: #Beta hasValue: 'beta'.! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 16:22'!
testLoadSlice
	| versions snapshot |
	versions := Set 
		with: (builder versionFor: #Alpha)
		with: (builder versionFor: #Beta).
	snapshot := slice snapshotWithVersions: versions.
	repository putAll: versions.
	repository put: snapshot.
	bench load: snapshot from: repository slice: slice.
	self assert: (bench assemblyForEnum: slice) = snapshot.
	self assert: #Alpha hasValue: 'alpha'.
	self assert: #Beta hasValue: 'beta'.! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2010 00:25'!
testRepeatedSaveBundle
	| first second bundle |
	self setAlphaToOne.
	bundle := MDBundle forTesting.
	bundle addSlice: slice.
	first := bench save: bundle to: repository.
	second := bench save: bundle to: repository.
	self assert: first = second! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2010 00:13'!
testRepeatedSaveSlice
	| first second |
	self setAlphaToOne.
	first := bench save: slice to: repository.
	second := bench save: slice to: repository.
	self assert: first = second! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 10:12'!
testSaveBundle
	| bundle baseline snapshot |
	self setAlphaToOne.
	bundle := MDBundle forTesting.
	bundle addSlice: slice.
	baseline := bench save: bundle to: repository.
	self assert: baseline bundleId = bundle id.
	self assert: (repository objects includes: baseline).
	self assert: baseline contents size = 1.
	snapshot := repository get: baseline contents anyOne.
	self assert: (snapshot isKindOf: MDSnapshot).
	self assert: snapshot sliceId = slice id.! !

!MDBenchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 10:08'!
testSaveSlice
	| snapshot |
	snapshot := bench save: slice to: repository.
	self assert: snapshot sliceId = slice id.
	self assert: (repository objects includes: snapshot).
	snapshot contents do: 
		[ :ea || version |
		version := repository get: ea.
		self assert: (version isKindOf: MDVersion) ].
! !

TestCase subclass: #MDBundleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDBundleTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:04'!
testAddSlice
	| bundle slice |
	bundle := MDBundle forTesting.
	slice := MDExplicitSlice forTesting.
	bundle addSlice: slice.
	self assert: (bundle includesSlice: slice)! !

!MDBundleTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:04'!
testCreation
	| bundle |
	bundle := MDBundle named: 'TestBundle'.
	self assert: bundle name = 'TestBundle'.
	self assert: (bundle id isKindOf: MDHashstamp)! !

!MDBundleTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:03'!
testCreationWithId
	| bundle id |
	id := MDHashstamp new.
	bundle := MDBundle id: id name: 'TestBundle'.
	self assert: bundle name = 'TestBundle'.
	self assert: bundle id = id! !

TestCase subclass: #MDDefaultFacadeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDDefaultFacadeTest methodsFor: 'asserting' stamp: 'cwp 7/20/2010 09:10'!
assertDefaultIdentityFor: aSymbol
	| first second |
	first := MDFacade defaultForType: aSymbol.
	second := MDFacade defaultForType: aSymbol.
	self assert: first == second! !

TestCase subclass: #MDFacadeTest
	instanceVariableNames: 'builder facade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDFacadeTest subclass: #MDChangeTest
	instanceVariableNames: 'workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:08'!
setUp
	facade := MDFakeFacade new.
	workspace := MDWorkspace forFacade: facade.! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:08'!
testAddition
	| change element |
	element := self builder element.
	self atProperty: #one put: 'beta'.
	change := workspace changeForElement: element do: [ :v | v ].
	self assert: (change version isKindOf: MDNullVersion).
	self assert: change variant element = element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:08'!
testModification
	| version change |
	version := self builder versionWith: 'alpha'.
	workspace loadVersion: version.
	self atProperty: #one put: 'beta'.
	change := workspace changeForElement: version element do: [ :v | v ].
	self assert: change version = version.
	self assert: change variant element = version element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:08'!
testNoChange
	| version change |
	version := self builder versionWith: 'alpha'.
	workspace loadVersion: version.
	change := workspace changeForElement: version element do: [ :v | self fail ].
	self assert: change isNil! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:09'!
testRemoval
	| version change |
	version := self builder versionWith: 'alpha'.
	workspace loadVersion: version.
	facade removeElement: version element.
	change := workspace changeForElement: version element do: [ :v | v ].
	self assert: change version = version.
	self assert: change variant isRemoval! !

MDFacadeTest subclass: #MDFacadeOpsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDFacadeOpsTest methodsFor: 'running' stamp: 'cwp 7/20/2010 10:16'!
setUp
	facade := MDFakeFacade new! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testCurrentDefinition
	| variant |
	self atElement: self builder element property: #one put: 1.
	variant := self builder definition.
	facade updateVariant: variant.
	self assert: (variant properties at: #one) = 1! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testIsLoadable
	| variant |
	variant := self builder definition.
	variant properties at: #one put: 1.
	self assert: (facade isLoadable: variant)! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testLoadAndUpdate
	| original retrieved |
	original := self builder definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	facade loadVariant: original.
	retrieved := facade updateVariant: self builder definition.
	self assert: original properties = retrieved properties! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testLoadAndUpdateRemoval
	| original retrieved |
	original := self builder definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	facade loadVariant: original.
	retrieved := facade updateVariant: self builder removal.
	self assert: retrieved properties = original properties! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testLoadDefinition
	| variant |
	variant := self builder definition.
	(variant properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	facade loadVariant: variant.
	self assert: (self atElement: self builder element property: #one) = 1.
	self assert: (self atElement: self builder element property: #two) = 2.
	self assert: (self atElement: self builder element property: #three) = 3! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testLoadRemoveAndUpdate
	| original retrieved |
	original := self builder definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	facade loadVariant: original.
	facade loadVariant: self builder removal.
	retrieved := facade updateVariant: self builder definition.
	self assert: retrieved element = self builder element.
	self assert: retrieved isRemoval! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testNotLoadable
	| variant |
	variant := self builder definition: #'Alpha/Delta'.
	variant properties at: #one put: 1.
	self deny: (facade isLoadable: variant)! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testRemoval
	| variant |
	self atElement: self builder element property: #one put: '1'.
	variant := self builder removal.
	facade loadVariant: variant.
	self assert: (self atElement: self builder element property: #one) isNil! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testRemovalLoadable
	| variant |
	variant := self builder removal: #'Alpha/Delta'.
	self assert: (facade isLoadable: variant)! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testRemovalUpToDate
	| variant removal |
	variant := self builder definition.
	removal := self builder removal.
	variant properties one: '1'.
	facade loadVariant: variant.
	self deny: (facade isUpToDate: removal).
	facade loadVariant: removal.
	self assert: (facade isUpToDate: removal)! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testTransaction
	| variant |
	variant := self builder definition.
	variant properties at: #one put: 1.
	facade transaction: [ facade loadVariant: variant ].
	self assert: (self atElement: self builder element property: #one) = 1! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testUpToDate
	| variant |
	variant := self builder definition.
	variant properties source: 'one ^ 1'.
	facade loadVariant: variant.
	self assert: (facade isUpToDate: variant).
	self atElement: self builder element property: #source put: 'one ^ 11'.
	self deny: (facade isUpToDate: variant)! !

!MDFacadeOpsTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testUpdateDoesntChangeElement
	| variant original |
	variant := self builder definition.
	original := variant element.
	facade updateVariant: variant.
	self assert: variant element = original! !

!MDFacadeTest class methodsFor: 'testing' stamp: 'cwp 7/20/2010 09:18'!
isAbstract
	^ self name = #MDFacadeTest! !

!MDFacadeTest methodsFor: 'asserting' stamp: 'cwp 7/13/2010 16:05'!
assertElement: elem property: prop hasValue: value
	self assert: (self atElement: (self builder element: elem) property: prop) = value! !

!MDFacadeTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:52'!
assertElementHasDefaultValue: aSymbol
	self assertElement: aSymbol property: #one hasValue: aSymbol asLowercase! !

!MDFacadeTest methodsFor: 'asserting' stamp: 'cwp 7/13/2010 16:05'!
assertElementHasValue: value
	self assert: (self atElement: self builder element property: #one) = value! !

!MDFacadeTest methodsFor: 'proxy access' stamp: 'cwp 7/20/2010 09:15'!
atElement: element property: property 
	^ (facade at: element) 
		at: property
		ifAbsent: [ nil ]! !

!MDFacadeTest methodsFor: 'proxy access' stamp: 'cwp 7/20/2010 09:15'!
atElement: element property: property put: value 
	"This will need to be overriden in tests that use a real image proxy."
	(facade at: element) 
		at: property
		put: value! !

!MDFacadeTest methodsFor: 'proxy access' stamp: 'cwp 7/13/2010 16:05'!
atProperty: aSymbol
	^ self atElement: self builder element property: aSymbol! !

!MDFacadeTest methodsFor: 'proxy access' stamp: 'cwp 7/13/2010 16:05'!
atProperty: aSymbol put: aValue
	self atElement: self builder element property: aSymbol put: aValue! !

!MDFacadeTest methodsFor: 'accessing' stamp: 'cwp 8/6/2010 16:12'!
builder
	^ builder ifNil: [builder := super builder]! !

!MDFacadeTest methodsFor: 'configuration' stamp: 'cwp 7/20/2010 09:17'!
facadeClass
	^ MDFakeFacade! !

MDFacadeTest subclass: #MDSliceOpsTest
	instanceVariableNames: 'repository snapshot workspace slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 7/13/2010 16:08'!
prepare
	self
		prepare: [ 
			self addToBoth: (self builder versionFor: #Alpha with: 'alpha').
			self addToBoth: (self builder versionFor: #Beta with: 'beta') ]! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 8/17/2010 10:00'!
prepare: aBlock
	| repositoryVersions |
	repository := Set new.
	snapshot := Set new.
	aBlock value.
	repositoryVersions := repository.
	repository := MDMemoryRepository forTesting.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot := self slice snapshotWithVersions: snapshot
	
	! !

!MDSliceOpsTest methodsFor: 'running' stamp: 'cwp 7/20/2010 10:14'!
setUp
	facade := MDFakeFacade new.
	workspace := MDWorkspace forFacade: facade.! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 8/17/2010 10:02'!
slice
	^ slice ifNil:
		[slice := (MDExplicitSlice forTesting)
			addElement: (self builder element: #Alpha);
			addElement: (self builder element: #Beta);
			yourself]! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsExplicitSlice
	| original copy |
	original := self slice.
	copy := original asExplicitSlice.
	self assert: (copy isKindOf: MDExplicitSlice).
	self assert: copy elements = original elements! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadEqualSnapshot
	self prepare.
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:05'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha := self builder element: #Alpha.
	beta := self builder element: #Beta.
	slice := MDExplicitSlice forTesting.
	slice addElement: alpha.
	slice load: snapshot from: repository to: workspace.
	self assert: (self atElement: alpha property: #one) = 'alpha'.
	self assert: (self atElement: beta property: #one) = 'beta'.
	self assert: slice elements size = 1! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadSmallerSnapshot
	self prepare: [ self addToBoth: (self builder versionFor: #Alpha with: 'alpha') ].
	self slice load: snapshot from: repository to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self assertElement: #Beta property: #one hasValue: nil! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadWithDepenencies
	self
		prepare: [ 
			self addToBoth: (self builder versionFor: #Alpha).
			self addToBoth: (self builder versionFor: #Beta).
			self addToBoth: (self builder versionFor: #'Alpha/Delta' with: 'ad') ].
	self slice load: snapshot from: repository to: workspace.
	self
		assertElementHasDefaultValue: #Alpha;
		assertElementHasDefaultValue: #Beta;
		assertElement: #'Alpha/Delta' property: #one hasValue: 'ad'! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 8/9/2010 10:31'!
testSave
	| slice versions |
	self prepare: [  ].
	slice := self slice.
	snapshot := slice saveFrom: workspace to: repository.
	versions := snapshot getVersionsFrom: repository.
	slice do: [ :element | self assert: (versions anySatisfy: [ :version | version element = element ]) ].
	self deny: (repository get: snapshot hashstamp) isNil.
! !

MDFacadeTest subclass: #MDWorkspaceTest
	instanceVariableNames: 'workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: [ :a :b | ^ self ].
	self assert: false! !

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertNoConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: 
			[ :a :b | 
			self assert: false.
			^ self ]! !

!MDWorkspaceTest methodsFor: 'running' stamp: 'cwp 7/20/2010 10:14'!
setUp
	facade := MDFakeFacade new.
	workspace := MDWorkspace forFacade: facade.! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testIncludeAbsentVersion
	| version |
	version := self builder version.
	version variant properties one: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #one) = 'bar'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version := self builder version.
	version variant properties source: 'one'.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	newVersion2 := self builder updateVersion: version property: #source put: 'three'.
	workspace loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testIncludeNewVersion
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testIncludeOldVersion
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoad
	| version |
	version := self builder version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (self atProperty: #one) = '1'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadAndSave
	| version |
	version := self builder version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testLoadDeleteAndSave
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	facade removeElement: version element.
	newVersion := workspace versionForElement: version element.
	workspace loadVersion: newVersion.
	self deny: (facade includesElement: version element)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadModifyAndSave
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := workspace versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self builder version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := workspace versionForElement: version element.
	newVersion2 := workspace versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testLoadOldVersion
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	workspace loadVersion: version.
	self assert: (self atProperty: #source) = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version := self builder version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self builder version.
	version variant properties source: 'one'.
	newVersion := self builder updateVersion: version property: #source put: 'two'.
	newVersion2 := self builder updateVersion: version property: #source put: 'three'.
	workspace loadVersion: newVersion.
	workspace
		includeVersion: newVersion2
		onConflict: [ :a :b | 
			self assert: a variant properties source = 'two'.
			b variant ].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := workspace versionForElement: version element.
	self assert: mergedVersion variant = newVersion2 variant.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:08'!
testSaveAbsentVersion
	| saved constructed |
	saved := workspace versionForElement: self builder element.
	constructed := self builder versionFor: #Alpha.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/13/2010 16:05'!
testSaveFirstVersion
	| version |
	self atElement: self builder element property: #one put: 'one'.
	version := workspace versionForElement: self builder element.
	self assert: version ancestry isEmpty.
	self assert: version variant properties one = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 7/20/2010 09:15'!
testTransaction
	| version |
	version := self builder version.
	version variant properties one: '1'.
	workspace
		transaction: [ 
			workspace loadVersion: version.
			self deny: (facade includesElement: version element) ].
	self assert: (self atProperty: #one) = '1'! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDHashstampTest methodsFor: 'support' stamp: 'cwp 8/8/2009 16:19'!
tag
	^ #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testCheckByte
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp checkByte = 251! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:04'!
testEqual
	| first second now |
	now := MDTimestamp now.
	first := MDHashstamp timestamp: now.
	second := MDHashstamp tag: first tag timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:11'!
testHash
	| first second now tag |
	now := MDTimestamp now.
	tag := self tag.
	first := MDHashstamp tag: tag timestamp: now.
	tag at: 1 put: 20.
	second := MDHashstamp tag: tag timestamp: now.
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:31'!
testInvalid
	| hashstamp byte |
	hashstamp := MDHashstamp new.
	byte := hashstamp checkByte + 1.
	byte < 0 ifTrue: [byte := 255].
	byte > 255 ifTrue: [byte := 0].
	hashstamp at: 24 put: byte.
	self deny: hashstamp isValid! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLessThan
	| first second |
	first := MDHashstamp fromString: 'bjrm0RTKT7KesZu0C1N9d0Dv+-Fez-No'.
	second := MDHashstamp fromString: 'c0qD0lTwM3oFdWJn9yYiSxGZjuhr9NHe'.
	self assert: first <= second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:18'!
testNew
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp size = MDHashstamp hashstampSize.
	self assert: (MDTimestamp now asInteger - hashstamp timestamp asInteger) < 5.
	self assert: hashstamp tag size = 19.
	self assert: hashstamp checkByte < 255.
	self assert: hashstamp isValid.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testPrinting
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: self tag
		timestamp: (MDTimestamp fromInteger: 929030771).
	self assert: hashstamp printString = 'BpzWQxTKT7KesZu0C1N9d0Dv+-Fez-Oq'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:12'!
testRead
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:16'!
testTag
	| hashstamp tag |
	tag := #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.
	hashstamp := MDHashstamp 
		tag: tag
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp tag = tag.
	self deny: hashstamp tag == tag! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 15:49'!
testTimestamp
	| first second now then |
	now := MDTimestamp now.
	then := MDTimestamp fromInteger: (now asInteger - 1).
	first := MDHashstamp timestamp: then.
	second := MDHashstamp timestamp: now.
	self deny: first timestamp = second timestamp.
	self deny: first = second! !

TestCase subclass: #MDHistorianTest
	instanceVariableNames: 'historian slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 8/17/2010 09:48'!
createMemo
	^ MDMemo 
		ancestry: MDAncestry empty
		properties: MDPropertyDictionary new
		slice: slice
		snapshot: (slice snapshotWithVersions: Set new)! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
markDirty
	| element |
	element := MDFakeElement named: #a.
	slice addElement: element.
	historian noteElementChanged: element.
! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/6/2008 18:45'!
memo
	^ self memoWithComment: 'This is a test'! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/8/2008 14:02'!
memoWithComment: aString
	^ [historian memo]
		on: MDCommentRequest
		do: [:req | req resume: aString]! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 1/18/2010 22:10'!
setUp
	slice := MDExplicitSlice forTesting.
	historian := MDHistorian forSlice: slice.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testCancelCommentRequest
	| memo |
	memo := self memoWithComment: nil.
	self assert: memo isNil! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComment
	| memo |
	memo := self memoWithComment: 'test123'.
	self assert: (memo properties comment = 'test123')! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/9/2008 22:25'!
testDirty
	
	self markDirty.
	self assert: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEmptyComment
	| memo |
	memo := self memoWithComment: ''.
	self deny: (memo properties includesKey: #comment)! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIncludeUpdatesOrdinal
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	second properties ordinal: 5.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoad
	
	| parent child |
	parent := self createMemo.
	historian noteLoad: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 1/22/2010 21:06'!
testLoadAndInclude
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.
	self assert: child ancestors size = 0.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadAndSave
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteSave: second.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = second hashstamp.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadClearsDirtyFlag
	
	| parent |
	self markDirty.
	parent := self createMemo.
	historian noteLoad: parent.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadUpdatesOrdinal
	
	| parent child |
	parent := self createMemo.
	parent properties ordinal: 5.
	historian noteLoad: parent.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/6/2008 19:23'!
testNoParents
	
	self assert: self memo parents isEmpty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNotDirty
	| element |
	element := MDFakeElement named: #a.
	historian noteElementChanged: element.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testOrdinalsIncreaseByOne
	| memo |
	self memo.
	memo := self memo.
	self assert: memo properties ordinal = 2! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:56'!
testOrdinalsStartAtOne

	self assert: self memo properties ordinal = 1! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPlatformProperties
	| properties memo |
	properties := MDPropertyDictionary new.
	MDPlatform current updateMemoProperties: properties.
	
	memo := self memo.
	properties keysAndValuesDo:
		[:k :v | self assert: (memo properties at: k) = v]! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 15:30'!
testSave
	
	| parent child |
	parent := self memo.
	parent setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp.
	self assert: child ancestors size = 0.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 15:30'!
testSaveAndInclude
	
	| child first second |
	first := self memo.
	second := self createMemo.
	first setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.
	self assert: child ancestors size = 0.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 15:30'!
testSaveClearsDirtyFlag
	| parent |
	self markDirty.	
	parent := self memo.
	parent setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: parent.
	
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 15:30'!
testSaveTwice
	
	| parent child grandchild |
	parent := self memo.
	parent setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: parent.
	child := self memo.
	child setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: child.
	grandchild := self memo.
	self assert: grandchild parents size = 1.
	self assert: grandchild ancestors size = 1.
	self assert: grandchild ancestors anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 15:30'!
testSaveTwiceAndInclude
	
	| parent child second grandchild |
	parent := self memo.
	parent setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: parent.
	child := self memo.
	child setAssembly: (slice snapshotWithVersions: Set new) enumeration: slice. 
	historian noteSave: child.
	second := self createMemo.
	historian noteInclude: second.
	grandchild := self memo.
	self assert: grandchild ancestors size = 1.
	self assert: grandchild ancestors anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/8/2008 21:16'!
testStartsClean
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:57'!
testUpdate
	
	historian properties abc: 123.
	self assert: self memo properties abc = 123! !

TestCase subclass: #MDMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:04'!
isAbstract
	^ self name = #MDMaterializerTest! !

MDMaterializerTest subclass: #MDUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 12:30'!
assert: aByteArray yields: expected
	| actual |
	actual := SMMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/2/2009 23:41'!
testAboriginal
	self
		assert: #(15 9 3 225 144 129 225 144 130 225 144 131)
		yields: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:36'!
testAscii
	self
		assert: #(15 9 3 97 98 99)
		yields: 'abc'! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/2/2009 23:44'!
testLatin
	self
		assert: #(15 9 3 195 161 98 99)
		yields: (MDPlatform current stringFromUnicode: #(225 98 99))! !

TestCase subclass: #MDMemoTest
	instanceVariableNames: 'memo snapshot slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/22/2010 20:47'!
ancestry
	^ MDAncestry 
		parents: (Array with: MDHashstamp new with: MDHashstamp new)
		ancestors: Set new! !

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:13'!
properties
	^ MDPropertyDictionary new! !

!MDMemoTest methodsFor: 'running' stamp: 'cwp 8/17/2010 15:30'!
setUp
	memo := MDMemo ancestry: self ancestry properties: self properties.
	slice := self builder slice.
	snapshot := slice snapshotWithVersions: self builder versions.
	memo setAssembly: snapshot enumeration: slice! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 8/10/2009 22:05'!
testDescription
	memo 
		instVarNamed: 'hashstamp' 
		put: (MDHashstamp timestamp: (MDTimestamp fromInteger: 886029518)).
	memo properties 
		author: 'Colin Putney <cputney@wireong.ca>';
		comment: 'Snapshot for testing.';
		initials: 'cwp';
		ordinal: 1;
		sliceName: 'Bogus'.
	self assert: memo description = 'timestamp: 28 March 2008 11:18:38 pm
author: ''Colin Putney <cputney@wireong.ca>''

Snapshot for testing.'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 11/17/2007 01:27'!
testName
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	self assert: memo name = 'TestSlice-abc.23'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:36'!
testProperties
	self assert: (memo properties isKindOf: MDPropertyDictionary)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:38'!
testSlice
	self assert: (memo matchesSlice: slice)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 23:01'!
testSliceName
	self assert: (memo sliceName = slice name)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:37'!
testSnapshot
	self assert: (memo hashstamp isKindOf: MDHashstamp).
	self assert: (memo reference isKindOf: MDHashstamp).
	self assert: memo reference = snapshot hashstamp.
	self deny: memo reference = memo hashstamp.
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByAuthor
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abd'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 23.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinal
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinalFirst
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abd'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutAuthors
	| other |
	other := memo deepCopy.
	memo properties ordinal: 23.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutOrdinals
	| other |
	other := memo deepCopy.
	memo properties initials: 'abd'.
	other properties initials: 'abc'.
	self assert: other <= memo! !

TestCase subclass: #MDPropertyDictionaryTest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
setUp
	properties := MDPropertyDictionary new.! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:32'!
testGetNil
	self assert: (properties at: #undefined) isNil! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:29'!
testImplicitGet
	properties at: #one put: 1.
	self assert: properties one = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
testImplicitPut
	properties one: 1.
	self assert: (properties at: #one) = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:30'!
testPutNil
	properties at: #undefined put: nil.
	self assert: properties isEmpty! !

TestCase subclass: #MDRegistryTest
	instanceVariableNames: 'registry slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2010 22:11'!
setUp
	registry := MDRegistry new.
	slice := MDExplicitSlice forTesting.
! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testIncludesId
	registry register: slice.
	self assert: (registry includesId: slice id)! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testObjectWithIdSatsifies
	registry register: slice.
	self assert: (registry objectWithId: slice id satisfies: [:o | o == slice]) ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRegistration
	registry register: slice.
	self assert: (registry objectWithId: slice id) == slice ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRemoval
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testRemoveId
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testUnregister
	registry register: slice.
	registry unregister: slice.
	self assert: registry objects isEmpty! !

TestCase subclass: #MDReplicatorTest
	instanceVariableNames: 'source dest replicator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:00'!
assertDestIncludesMemo: memo 
	| snapshot |
	self assert: (dest memos includes: memo).
	self assert: (dest allHashstamps includes: memo reference).
	snapshot := dest get: memo reference.
	self assert: (dest allHashstamps includesAllOf: snapshot contents)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 15:30'!
buildSource: aSymbol
	| versions builder snapshot memo properties slice |
	builder := MDTestBuilder new.
	slice := builder slice.
	versions := #(#alpha #beta #gamma) collect: 
		[:letter || v |
		v := builder versionFor: letter with: letter.
		source put: v.
		v ].
	snapshot := slice snapshotWithVersions: versions.
	source put: snapshot.
	properties := MDPropertyDictionary new.
	properties tag: aSymbol.
	memo := MDMemo ancestry: MDAncestry empty properties: properties.
	memo setAssembly: snapshot enumeration: slice.
	source put: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2010 22:39'!
setUp
	source := MDMemoryRepository forTesting.
	dest := MDMemoryRepository forTesting.
	replicator := MDReplicator 
		from: source
		to: dest.
	self buildSource: #one! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:52'!
testCopyAll
	replicator copyAll.
	self assert: (dest selectFrom: source allHashstamps) isEmpty! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:54'!
testCopyAllReferenced
	| version |
	version := MDTestBuilder new 
		versionFor: #zappa
		with: #fribbitz.
	source put: version.
	replicator copyAll.
	self deny: (dest includes: version)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2008 22:15'!
testCopyMemo
	| memo |
	memo := source memos anyOne.
	replicator copyMemo: memo.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:03'!
testReject
	| memo |
	self buildSource: #two.
	replicator reject: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #one.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:02'!
testSelect
	| memo |
	self buildSource: #two.
	replicator select: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #two.
	self assertDestIncludesMemo: memo! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 5/24/2008 13:07'!
newRepository
	^ MDMemoryRepository named: 'test'! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

!MDRepositoryTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 11:41'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	self assert: (SMSerializer serialize: anElementVersion) = (SMSerializer serialize: otherElementVersion)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 8/17/2010 15:30'!
memo
	| memo snapshot slice |
	slice := self slice.
	snapshot := self snapshot: slice.
	memo := MDMemo new.
	memo setAssembly: snapshot enumeration: slice.
	^ memo! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 12/23/2007 00:09'!
secondRepository
	^ self newRepository! !

!MDRepositoryTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:10'!
setUp
	repository := self newRepository! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 1/18/2010 22:11'!
slice
	^ MDExplicitSlice forTesting! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 8/17/2010 09:56'!
snapshot
	^ self snapshot: self slice ! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 8/17/2010 09:56'!
snapshot: aSlice
	^ aSlice snapshotWithVersions: (Set with: self version)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testGetUnknownVersion
	| snapshot |
	snapshot := self snapshot.
	self assert: (repository get: snapshot hashstamp) isNil! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testId
	self assert: (repository id isKindOf: MDHashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMemos
	| memo memos |
	
	memo := self memo.
	repository put: memo.
	
	memos :=  repository memos.
	
	self assert: memos size = 1.
	self assert: (memos anyOne = memo).
! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPush
	| other version |
	other := self secondRepository.
	version := self version.
	repository put: version.
	repository pushTo: other.
	self assert: (other includes: version hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreSnapshot
	| snapshot |
	snapshot := self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreVersion
	| version |
	version := self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSynchronizeWith
	| versionOne versionTwo other |
	versionOne := self version.
	repository put: versionOne.
	
	other := self secondRepository.
	versionTwo := self version.
	other put: versionTwo.
	
	repository synchronizeWith: other.
	
	self assert: (repository includes: versionTwo hashstamp).
	self assert: (other includes: versionOne hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testTimestamp
	self assert: (repository id timestamp isKindOf: MDTimestamp)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'dc 6/21/2007 18:31'!
version
	^ (MDFakeElement named: #Alpha) newElementVersion! !

TestCase subclass: #MDSerializationBytesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationBytesTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 11:41'!
assert: anObject serializesTo: anArray 
	| expected actual |
	actual := SMSerializer serialize: anObject.
	expected := anArray asByteArray.
	self assert: actual = expected! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testDefinitionVariant
	| definition |
	definition := MDTestBuilder new definition.
 	self assert: definition serializesTo: #(1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:03'!
testFakeElement
| element |
	element := MDTestBuilder new element.
	self assert: element serializesTo: #(1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:14'!
testHashstamp
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62) asByteArray
		timestamp: (MDTimestamp fromInteger: 905800829).
	self 
		assert: hashstamp 
		serializesTo: #(22 53 253 108 125 125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62 31)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/23/2010 11:41'!
testMemo
	| memo |
	memo := MDTestBuilder new memo.
	memo instVarAt: 1 put: (MDHashstamp fromString: 'BTpiEUqnmCG0M-vpGmAqClg7Epiwyh+k').
	memo instVarAt: 2 put: (MDHashstamp fromString: 'BTpifCLy1McVFvfIDx7ZkWv5YA5quh3d').
	memo instVarAt: 5 put: (MDHashstamp fromString: 'Bq-Yoy3kfy4i+GisbhjJr6tIIPB7lHFr').
	SMSerializer serialize: memo.
	self 
		assert: memo 
		serializesTo: #[23 5 9 7 22 53 253 110 66 13 179 200 228 130 96 30 245 75 35 54 59 27 9 67 91 188 250 208 48 22 53 253 110 172 229 254 13 138 33 71 186 212 63 210 101 194 46 199 144 193 246 234 209 105 1 2 14 9 10 77 68 65 110 99 101 115 116 114 121 9 2 15 9 7 112 97 114 101 110 116 115 15 9 9 97 110 99 101 115 116 111 114 115 17 9 0 18 9 0 20 9 2 14 9 2 105 100 14 9 3 97 98 99 14 9 9 115 108 105 99 101 78 97 109 101 15 9 9 84 101 115 116 83 108 105 99 101 22 55 96 100 211 225 112 175 225 174 1 43 184 158 219 213 220 142 84 81 179 73 197 52 119]! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:37'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new
		first: 1;
		second: 'two';
		yourself.

	self
		assert: properties
		serializesTo: #(20 9 2 14 9 5 102 105 114 115 116 9 1 
					14 9 6 115 101 99 111 110 100 15 9 3 116 
					119 111)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testRemovalVariant
| removal |
	removal := MDTestBuilder new removal.
	self assert: removal serializesTo: #(1 5 9 3 1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/17/2010 10:07'!
testSnapshot
| contents snapshot |
	contents := #('BTploHISPGtEjxw7iNSRzI4sPrBSpkcx' 'BTploIM6Z+ffONzz9IfyCOaH7I8zZPk-') 
		collect: [:ea | MDHashstamp fromString: ea].
	snapshot := MDSnapshot new.
	snapshot instVarAt: 1 put: (MDTimestamp fromInteger: 905802042).
	snapshot instVarAt: 2 put: contents.

	self 
		assert: snapshot
		serializesTo: 
			#[23 5 9 6 21 53 253 113 58 17 9 2 22 53 253 113 209 53 30
			109 46 80 191 223 9 185 151 157 253 65 184 111 115 94 215 
			10 61 22 53 253 113 209 70 8 148 10 235 105 159 255 45 74
			254 57 169 147 37 66 191 149 188 1 6]! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:58'!
testTimestamp
	| ts |
	ts := MDTimestamp fromInteger: 905803057.
	self assert: ts serializesTo: #(21 53 253 117 49)	! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 2/2/2010 20:40'!
testVersion
	| version |
	version := MDTestBuilder new version.
	version instVarAt: 1 put: (MDTimestamp fromInteger: 905803456).
	self 
		assert: version
		serializesTo: #[23 5 9 5 21 53 253 118 192 1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0 1 2 14 9 10 77 68 65 110 99 101 115 116 114 121 9 2 15 9 7 112 97 114 101 110 116 115 15 9 9 97 110 99 101 115 116 111 114 115 17 9 0 18 9 0]! !

TestCase subclass: #MDSerializationClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationClassTest commentStamp: 'cwp 4/19/2008 14:31' prior: 0!
This suite of tests ensures that well-known classes are serialized using these class ids:

	    -- core --
	 1  MDSliceElement
	 2  MDDefinitionVariant
	 3  MDRemovalVariant
	 4  MDNullVersion
	 5  MDElementVersion
	 6  MDSnapshot
	 7  MDMemo

	     -- testing --
	 8  MDFakeElement

	    -- smalltalk --
	 9  MDClassElement
	10  MDClassCommentElement
	11  MDInstVarElement
	12  MDClassVarElement
	13  MDClassInstVarElement
	14  MDMethodElement

!

!MDSerializationClassTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 11:41'!
assert: anObject hasClassId: anInteger
	| bytes |
	bytes := SMSerializer serialize: anObject.
	self assert: (#(1 23) includes: bytes first).	"type object"
	self assert: bytes second = 5.					"well-known class"
	self assert: bytes third = 9.					"byte integer"
	self assert: bytes fourth = anInteger! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'jf 11/8/2009 19:49'!
test02DefinitionVariant
	self 
		assert: MDDefinitionVariant forTesting
		hasClassId: 2! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'jf 11/8/2009 19:49'!
test03RemovalVariant
	self 
		assert: MDRemovalVariant forTesting
		hasClassId: 3! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:17'!
test04NullVersion
	self 
		assert: MDNullVersion new
		hasClassId: 4! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:23'!
test05ElementVersion
	self 
		assert: MDElementVersion new
		hasClassId: 5! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:23'!
test06Snapshot
	self 
		assert: MDSnapshot new
		hasClassId: 6! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:24'!
test07Memo
	self 
		assert: MDMemo new
		hasClassId: 7! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:25'!
test08FakeElement
	self 
		assert: MDFakeElement new
		hasClassId: 8! !

TestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 12:30'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := SMSerializer serialize: anObject.
	other := SMMaterializer materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/2/2008 11:04'!
assertIdentityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after == before]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:13'!
testArray
	self assertEqualityOf: #(1 2 3)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:02'!
testBytesObject
	self assertEqualityOf: #(1 2 3) asByteArray! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:45'!
testClass
	self assertIdentityOf: self class! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testDefinitionVariant
	self assertEqualityOf: self builder definition! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:29'!
testDictionary
	| dict |
	dict := Dictionary new
			at: #a put: 1;
			at: #b put: 2;
			yourself.
	self assertEqualityOf: dict! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:05'!
testFakeElement
	self assertEqualityOf: self builder element! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testFalse
	self assertIdentityOf: false ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/8/2009 17:30'!
testHashstamp
	self assertEqualityOf: MDHashstamp new! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:06'!
testMemo
	self assertEqualityOf: self builder memo! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/23/2008 13:22'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testNegativeLargeInteger
	self assertEqualityOf: SmallInteger minVal - 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 02:03'!
testNegativeOneByteInteger
	self assertEqualityOf: -3! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:20'!
testNegativeTwoByteInteger
	self assertEqualityOf: -300! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:05'!
testNil
	self assertIdentityOf: nil! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:06'!
testPointersObject
	self assertEqualityOf: MDPlatform current variablePointersObject ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testPositiveLargeInteger
	self assertEqualityOf: SmallInteger maxVal + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testRemovalVariant
	self assertEqualityOf: self builder removal! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:25'!
testSet
	self assertEqualityOf: #(1 2 3) asSet! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:08'!
testSnapshot
	self assertEqualityOf: self builder snapshot! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 4/15/2008 21:40'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/5/2008 22:29'!
testThreeByteInteger
	self assertEqualityOf: (2 raisedTo: 16) + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/23/2010 12:30'!
testTimestamp
	| ts buffer |
	ts := MDTimestamp now.
	buffer := SMSerializer serialize: ts.
	self assert: buffer size = 5.
	self assert: (SMMaterializer materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testTrue
	self assertIdentityOf: true! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:08'!
testVersion
	self
		assertEqualityOf: self builder version
		using: [ :before :after | 
			self assert: before variant = after variant.
			self assert: before hashstamp = after hashstamp.
			self assert: before ancestry = after ancestry ]! !

TestCase subclass: #MDSerializationTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationTypeTest commentStamp: 'cwp 4/19/2008 12:04' prior: 0!
Here's the type specifications that this class enforces:

     1  object
     2  class (fixed)
     3  class (pointers)
     4  class (bytes)
     5  class (well-known)
     6  nil
     7  true
     8  false
     9  8 bit unsigned integer
    10  small positive integer
    11  small negative integer
    12  large positive integer
    13  large negative integer
    14  symbol (utf-8)
    15  string (utf-8)
    16  string (utf-16be)
    17  array
    18  set
    19  dictionary
    20  properties
    21  timestamp
    22  hashstamp
    23  hashed object!

!MDSerializationTypeTest methodsFor: 'asserting' stamp: 'cwp 9/9/2010 20:36'!
assertObject: anObject hasType: anInteger
	| bytes |
	bytes := MDSerializer serialize: anObject.
	self assert: bytes first = 242.
	self assert: bytes second = anInteger! !

!MDSerializationTypeTest methodsFor: 'running' stamp: 'cwp 11/8/2009 21:49'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test20Properties
	self
		assertObject: MDPropertyDictionary new
		hasType: 20! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test21Timestamp
	self
		assertObject: MDTimestamp now
		hasType: 21! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test22Hashstamp
	self
		assertObject: (MDHashstamp fromString: 'AbjG2m8xWqxTBPAOm0Sq4bCsci7JbfKX')
		hasType: 22! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 09:58'!
test23HashedObject
	self
		assertObject: (MDSnapshot sliceId: MDHashstamp new versions: Set new)
		hasType: 23! !

TestCase subclass: #MDSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:06'!
isAbstract
	^ self name = #MDSerializerTest! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writeStream.
	self serialize: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 18:54'!
serialize: anObject on: aStream
	self subclassResponsibility! !

MDSerializerTest subclass: #MDUtf16SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf16String: anObject.! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAboriginal
	self 
		assert: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[250 3 20 1 20 2 20 3]! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAscii
	self 
		assert: 'abc' 
		yields: #[250 3 0 97 0 98 0 99]! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:25'!
testLatin
	self 
		assert: (MDPlatform current stringFromUnicode: #(225 98 99))
		yields: #[250 3 0 225 0 98 0 99]
	! !

MDSerializerTest subclass: #MDUtf8SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf8String: anObject.! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:25'!
testAboriginal
	self 
		assert: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[251 3 225 144 129 225 144 130 225 144 131]! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testAscii
	self assert: 'abc' yields: #(251 3 97 98 99)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testLatin
	self 
		assert: (MDPlatform current stringFromUnicode: #(225 98 99)) 
		yields: #[251 3 195 161 98 99]! !

TestCase subclass: #MDSliceTest
	instanceVariableNames: 'slice elements environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSliceTest commentStamp: 'cwp 8/29/2005 00:40' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
isAbstract
	^ self name = #MDSliceTest! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
shouldInheritSelectors
	^ true! !

!MDSliceTest methodsFor: 'asserting' stamp: 'dc 6/26/2007 21:48'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels as: aBlock 
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock.
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock.! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 5/22/2008 00:10'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	forbidden := forbiddenLabels collect: aBlock.
	elements := slice elements.
	self assert: (elements includesAllOf: expected).
	self deny: (elements includesAnyOf: forbidden)! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:28'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].

	forbidden := forbiddenLabels collect: aBlock.
	forbidden do: [:ea | self deny: (slice includes: ea)]! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:56'!
environment
	^ environment ifNil: [ environment := MDEnvironment forTesting ]! !

!MDSliceTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:37'!
setUp
	slice := self environment addSlice: self createSlice! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:59'!
testId
	self assert: (slice id isKindOf: MDHashstamp)! !

TestCase subclass: #MDTimestampPrinterTest
	instanceVariableNames: 'ts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
assert: format prints: expected
	| actual |
	actual := ts printFormat: format.
	self assert: expected = actual! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testNativePrintOn
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 3
			minute: 2
			second: 1.
	self assert: '%e %B %Y %i:%M:%S %p' prints: '4 May 2006 3:02:01 am'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampAm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 1
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 01:02'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampPm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 15
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 15:02'! !

TestCase subclass: #MDTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
intWithBytes: anArray
	| int |
	int := 0.
	1 to: 4 do: [:i | int := (int bitShift: 8) + (anArray at: i)].
	^ int! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
recompose: units
	| int |
	int := MDTimestamp compose: units.
	^ (MDTimestamp fromInteger: int) decompose! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsInteger
	| int ts |
	int := self intWithBytes: #(1 2 3 4).
	ts := MDTimestamp fromInteger: int.
	self assert: ts asInteger = int.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testByteOrder
	| ts |
	ts := self tsWithBytes: #(1 2 3 4).
	self assert: (ts byteAt: 1) = 1.
	self assert: (ts byteAt: 2) = 2.
	self assert: (ts byteAt: 3) = 3.
	self assert: (ts byteAt: 4) = 4.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition1
	| units |
	units := #(1 2 3 4 5 6 7).
	self assert: (self recompose: units) = units! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition2
	| before after |
	before := #(7 3 5 4 3 2 1).
	after := self recompose: before.
	self assert: before = after! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/16/2005 16:50'!
testDays
	self assert: (self ts: #(2001 02 23 00 00 00)) day = 23.
	self assert: (self ts: #(2001 02 23 00 00 01)) day = 23.
	self assert: (self ts: #(2001 02 23 23 59 59)) day = 23.
	self assert: (self ts: #(2005 02 23 12 00 00)) day = 23.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:38'!
testEndOfEpoch
	self 
	should: [MDTimestamp fromInteger: MDTimestamp last asInteger + 1]
	raise: Error! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEpoch
	| ts |
	ts := MDTimestamp epoch.
	self assert: ts byteSize <= 4.
	self assert: ts asInteger = 0! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEquality
	| left right |
	left := MDTimestamp now.
	right := left copy.
	self deny: left == right.
	self assert: left = right.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour01
	self assert: (self ts: #(2001 02 23 00 00 00)) hour = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour02
	self assert: (self ts: #(2001 02 23 01 00 01)) hour = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour03
	self assert: (self ts: #(2001 02 23 23 59 59)) hour = 23.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:20'!
testHour04
	self assert: (self ts: #(2005 04 07 01 30 00)) hour = 1.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 23:02'!
testLeapYear
	| ts |
	ts := self ts: #(2004 02 29 01 00 00).
	self assert: ts day = 29.
	self assert: ts month = 2! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude01
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 5).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude02
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 4).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude03
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 3).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude04
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 4 4).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute01
	self assert: (self ts: #(2001 02 23 00 00 00)) minute = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute02
	self assert: (self ts: #(2001 02 23 01 01 01)) minute = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute03
	self assert: (self ts: #(2001 02 23 23 59 59)) minute = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMonths
	| base increment ts |
	base :=  24969600. 			"Value of Dec 15, the year of the epoch"
	increment := 86400 * 30.		"Number of seconds in 30 days"
	
	"Start at Jan 15, and add 30 days at a time, to test each month."
	1 to: 12 do: 
		[:i | 
		ts := MDTimestamp fromInteger: i * increment + base.
		self assert: ts month = i]! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNow
	| ts |
	ts := MDTimestamp now.
	self assert: ts size <= 4.
	self assert: ts asInteger positive! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting1
	| ts |
	ts := self ts: #(2000 03 01 00 00 00).
	self assert: ts printString = '1 March 2000 12:00:00 am'.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting2
	| ts |
	ts := self ts: #(2005 04 07 23 28 31).
	self assert: ts printString = '7 April 2005 11:28:31 pm'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting3
	| ts |
	ts := self ts: #(2005 04 07 03 28 31).
	self assert: ts printString = '7 April 2005 3:28:31 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testRange
	| begin end |
	begin := MDTimestamp epoch.
	end := MDTimestamp last.
	self assert: MDTimestamp range = (end asInteger - begin asInteger)! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond01
	self assert: (self ts: #(2001 02 23 00 00 00)) second = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond02
	self assert: (self ts: #(2001 02 23 01 01 01)) second = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond03
	self assert: (self ts: #(2001 02 23 23 59 59)) second = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear01
	self assert: (self ts: #(1984 02 28 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear02
	self assert: (self ts: #(1984 02 29 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear03
	self assert: (self ts: #(1984 03 01 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear04
	self assert: (self ts: #(2001 02 23 00 01 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear05
	self assert: (self ts: #(2001 02 28 23 59 59)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear06
	self assert: (self ts: #(2001 03 01 00 00 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear07
	self assert: (self ts: #(2001 03 01 00 00 01)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear08
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:30'!
testYear09
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:38'!
testYear10
	self assert: (self ts: #(2004 02 23 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:33'!
testYear11
	self assert: (self ts: #(2004 02 29 00 01 00)) year = 2004.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear12
	self assert: (self ts: #(2004 04 29 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear13
	self assert: (self ts: #(2005 02 23 00 01 00)) year = 2005.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 20:30'!
testYear14
	self assert: (self ts: #(2004 01 07 09 11 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 6/18/2005 16:04'!
ts: anArray
	| parts |
	parts := Array new: 6.
	parts atAllPut: 0.
	anArray withIndexDo: [:ea :i | parts at: i put: ea].
	^ MDTimestamp
		year: (parts at: 1)
		month: (parts at: 2)
		day: (parts at: 3)
		hour: (parts at: 4)
		minute: (parts at: 5)
		second: (parts at: 6)! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:25'!
tsWithBytes: anArray
	^ MDTimestamp fromInteger: (self intWithBytes: anArray)! !

!TestCase methodsFor: '*mc2-tests-core' stamp: 'cwp 7/13/2010 16:12'!
builder
	^ MDTestBuilder new! !

!TestCase methodsFor: '*mc2-tests-core' stamp: 'cwp 7/13/2010 16:12'!
fail
	self signalFailure: 'Assertion failed'! !
